<template>
    <div class="auto-assign">
        <span class="font-14 items-center">
            {{ $t('autoAssign.title') }}
        </span>
        <q-toggle
            size="md"
            v-model="state.toggleValue"
            color="green"
            :true-value="1"
            :false-value="0"
            :value="getSetting?.autoAssignFlag"
            @click="setAutoAssign"
        />
    </div>
</template>

<script lang="ts">
import { defineComponent, reactive, watch, computed, onMounted } from 'vue';
import { mapGetters } from 'vuex';
import { useStore } from 'src/store';
import localForage from 'localforage';

export default defineComponent({
    name: 'AutoAssign',
    computed: {
        ...mapGetters({
            getSetting: 'business/getSetting'
        })
    },
    setup() {
        // store
        const store = useStore();
        const settingStore = localForage.createInstance({
            name: 'lobbi/business'
        });

        // computed
        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        const selectedBranch = computed(() => {
            return store.state.branch.branch;
        });

        // data
        let state = reactive({
            toggleValue: {} as any,
            autoAssignValue: {} as any
        });

        // watch
        watch(selectedBusinessId, () => {
            // get settings
            if (selectedBusinessId.value && selectedBranch.value) {
                getSettings();
            }
        });

        // methods
        const setAutoAssign = async () => {
            if (
                selectedBusinessId.value &&
                selectedBranch.value?.length != ''
            ) {
                await store.dispatch('business/putSetting', {
                    businessId: selectedBusinessId.value,
                    autoAssignFlag: state.toggleValue,
                    maxActiveConversation:
                        store.getters['business/getSetting']
                            ?.maxActiveConversation,
                    issueTypeIds:
                        store.getters['business/getSetting']?.issueTypeIds
                });
            }
        };

        const getLocalForage = () => {
            settingStore.getItem('settings', function (err, value: any) {
                value = JSON.parse(value);
                if (value) {
                    state.autoAssignValue = value;
                }

                if (state.autoAssignValue.length > 0) {
                    const findIndex = state.autoAssignValue.findIndex(
                        (element: any) =>
                            element.businessId == selectedBusinessId.value
                    );

                    if (findIndex != -1) {
                        if (
                            state.autoAssignValue[findIndex].autoAssignFlag == 1
                        ) {
                            store.dispatch('business/putSetting', {
                                businessId: selectedBusinessId.value,
                                autoAssignFlag:
                                    state.autoAssignValue[findIndex]
                                        .autoAssignFlag,
                                maxActiveConversation:
                                    store.getters['business/getSetting']
                                        ?.maxActiveConversation,
                                issueTypeIds:
                                    store.getters['business/getSetting']
                                        ?.issueTypeIds
                            });
                        }
                    }
                }
            });
        };

        const getSettings = async () => {
            const result = await store.dispatch('business/getSetting', true);
            if (result) {
                getAutoAssignStatus();
            }
        };

        const getAutoAssignStatus = () => {
            state.toggleValue =
                store.getters['business/getSetting']?.autoAssignFlag;
        };

        // mounted
        onMounted(getSettings);
        onMounted(getLocalForage);

        return {
            state,
            setAutoAssign
        };
    }
});
</script>
